## net.sf.saxon.expr.sort
Class NumericComparer

    java.lang.Object
      net.sf.saxon.expr.sort.NumericComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

Direct Known Subclasses:
  NumericComparer11

    public class NumericComparer

extends Object
implements AtomicComparer, Serializable

A Comparer used for comparing sort keys when data-type="number". The items to be compared are converted to numbers, and the numbers are then compared directly. NaN values compare equal to each other, and equal to an empty sequence, but less than anything else.

This class is used in XSLT only, so there is no need to handle XQuery's "empty least" vs "empty greatest" options.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Field Summary
`protected StringToDouble` `converter`

Constructor Summary
`protected` `NumericComparer()`

Method Summary
`int` `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two Items by converting them to numbers and comparing the numeric values.
`boolean` `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`StringCollator` `getCollator()` Get the collation used by this AtomicComparer if any
`ComparisonKey` `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`static NumericComparer` `getInstance()`
`AtomicComparer` `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### converter

    protected StringToDouble converter

Constructor Detail

### NumericComparer

    protected NumericComparer()

Method Detail

### getInstance

    public static NumericComparer getInstance()

### getCollator

    public StringCollator getCollator()

  Description copied from interface: `AtomicComparer`
  Get the collation used by this AtomicComparer if any

  Specified by:
    `getCollator` in interface `AtomicComparer`
  Returns:
    the collation used for comparing strings, or null if not applicable

### provideContext

    public AtomicComparer provideContext(XPathContext context)

  Supply the dynamic context in case this is needed for the comparison

  Specified by:
    `provideContext` in interface `AtomicComparer`
  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two Items by converting them to numbers and comparing the numeric values. If either value cannot be converted to a number, it is treated as NaN, and compares less that the other (two NaN values compare equal).

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first Item to be compared.
    `b` - the second Item to be compared.
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `ClassCastException` - if the objects are not Items

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared.
    `b` - the second object to be compared.
  Returns:
    true if the values are equal, false if not
  Throws:
    `ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal according to the XPath eq operator, then their comparison keys are equal according to the Java equals() method, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.